--  Levels are 12x12
--  Tile 0 is None
--  Tile 1 is Wall
--  Tile 2 is Key
--  Tile 3 is Door
--  Tile 4 is Zap
--  Tile 5 is Zap2
--  Tile 6 is Tele
--  Tile 7 is Port
--  Tile 8 is Sign
--  Tile 9 is Next

function doNextLevel(text)
	GAMESTATE = 0
	LEVELDESC = text
	CURRENTLEVEL = CURRENTLEVEL + 1
end
function doChangeLevel()
	walltiles = {}
	keytiles = {}
	doortiles = {}
	zaptiles = {}
	nexttiles = {}
	teletiles = {}
	porttiles = {}
	signtiles = {}
	KEYS = 0
	CURRENTLEVEL = LEVELNEXT or CURRENTLEVEL
	loadUpLevel(allLevels[CURRENTLEVEL])
	LEVELNEXT = nil
end
function doWarpPortal()
	
end
function loadUpLevel(level)
	for k,v in pairs(level) do
		puty = math.floor((k-1)/12)
		putx = (k-1) - puty*12
		if v == 1 then
			table.insert(walltiles, walltile:New(putx*64, puty*64))
		end
		if v == 2 then
			table.insert(keytiles, keytile:New(putx*64, puty*64))
		end
		if v == 3 then
			table.insert(doortiles, doortile:New(putx*64, puty*64))
		end
		if v == 4 then
			table.insert(zaptiles, zaptile:New(putx*64, puty*64))
		end
		if v == 5 then
			table.insert(zaptiles, zaptile:New(putx*64, puty*64, 100))
		end
		if v == 6 then
			table.insert(teletiles, teletile:New(putx*64, puty*64))
		end
		if v == 7 then
			table.insert(porttiles, porttile:New(putx*64, puty*64))
		end
		if v == 8 then
			table.insert(signtiles, signtile:New(putx*64, puty*64))
		end
		if v == 9 then
			table.insert(nexttiles, nexttile:New(putx*64, puty*64))
		end
	end
	LEVELDESC = level[145] or "undefined"
	LEVELSIGN = level[146] or ""
	LEVELNEXT = level[147] or LEVELNEXT
end

allLevels = {
{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 9, 1,
1, 1, 1, 1, 1, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
"Good start!", nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 7, 1, 0, 6, 1,
1, 0, 0, 1, 0, 2, 2, 0, 1, 0, 0, 1,
1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 3, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 1,
1, 0, 0, 1, 0, 0, 0, 9, 1, 0, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
"Slick moves, brutha!", nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 4, 0, 5, 0, 5, 5, 1,
1, 0, 0, 0, 0, 0, 4, 0, 5, 0, 4, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 4, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 5, 4, 1,
1, 0, 0, 9, 0, 0, 0, 0, 1, 4, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 0, 4, 1,
1, 0, 0, 0, 0, 0, 0, 0, 1, 4, 0, 1,
1, 0, 0, 1, 1, 1, 1, 1, 1, 0, 5, 1,
1, 4, 0, 4, 0, 4, 5, 4, 5, 5, 0, 1,
1, 5, 4, 0, 0, 5, 5, 0, 5, 0, 4, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
"Great Job! Keep going...", nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 2, 2, 2, 2, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 3, 1, 1, 1, 1, 1,
1, 1, 1, 1, 1, 1, 4, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 9, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
"Cool!", nil
},

{
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 8, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1,
1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
"Great Job! Keep going...", "The End!\nThanks for testing this version. You rock! Any feedback or suggestions? Did you make a level? Post it!"
},

}