walltiles = {}
walltile = {}
function walltile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			doGameOver()
		end
	end
	function obj:draw()
		love.graphics.draw(wallimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
	end
	return obj
end
signtile = {}
signtile = {}
function signtile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			READINGSIGN = true
		end
	end
	function obj:draw()
		love.graphics.draw(signimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
	end
	return obj
end
nexttiles = {}
nexttile = {}
nexttilequad1 = love.graphics.newQuad(0, 0, 64, 64, 512, 64)
nexttilequad2 = love.graphics.newQuad(64, 0, 64, 64, 512, 64)
nexttilequad3 = love.graphics.newQuad(128, 0, 64, 64, 512, 64)
nexttilequad4 = love.graphics.newQuad(192, 0, 64, 64, 512, 64)
nexttilequad5 = love.graphics.newQuad(256, 0, 64, 64, 512, 64)
nexttilequad6 = love.graphics.newQuad(320, 0, 64, 64, 512, 64)
nexttilequad7 = love.graphics.newQuad(384, 0, 64, 64, 512, 64)
nexttilequad8 = love.graphics.newQuad(448, 0, 64, 64, 512, 64)
function nexttile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	obj.frame = 1
	obj.frametime = 0
	function obj:update(dt)
		self.frametime = self.frametime + 100*dt
		if self.frametime > 10 then
			self.frametime = 0
			self.frame = self.frame + 1
			if self.frame > 8 then
				self.frame = 1
			end
		end
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			nextsnd:stop()
			nextsnd:play()
			doNextLevel(LEVELDESC)
		end
	end
	function obj:draw()
		if self.frame == 1 then love.graphics.drawq(nextimg, nexttilequad1, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 2 then love.graphics.drawq(nextimg, nexttilequad2, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 3 then love.graphics.drawq(nextimg, nexttilequad3, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 4 then love.graphics.drawq(nextimg, nexttilequad4, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 5 then love.graphics.drawq(nextimg, nexttilequad5, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 6 then love.graphics.drawq(nextimg, nexttilequad6, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		elseif self.frame == 7 then love.graphics.drawq(nextimg, nexttilequad7, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
		else love.graphics.drawq(nextimg, nexttilequad8, self.x, self.y, 0, 1, 1, 0, 0, 0, 0) end
	end
	return obj
end
keytiles = {}
keytile = {}
function keytile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	obj.collected = false
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) and not self.collected then
			self.collected = true
			KEYS = KEYS + 1
			keysnd:stop()
			keysnd:play()
		end
	end
	function obj:draw()
		if not self.collected then love.graphics.draw(keyimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0) end
	end
	return obj
end
teletiles = {}
teletile = {}
function teletile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	function obj:update(dt)
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			doTelePort()
		end
	end
	function obj:draw()
		love.graphics.draw(teleimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
	end
	return obj
end
porttiles = {}
porttile = {}
function porttile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	function obj:update(dt)
		if TELEPORTING then
			love.mouse.setPosition(self.x+32, self.y+32)
			TELEPORTING = false
		end
	end
	function obj:draw()
		love.graphics.draw(portimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
	end
	return obj
end
zaptiles = {}
zaptile = {}
function zaptile:New(x, y, timeOffset)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	obj.zaptime = timeOffset or 0
	function obj:update(dt)
		self.zaptime = self.zaptime + 100*dt
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) and self.zaptime > 100 then
			doGameOver()
		end
		if self.zaptime > 200 then self.zaptime = 0 end
	end
	function obj:draw()
		if self.zaptime > 100 then love.graphics.draw(zapimg, self.x, self.y, 0, 1, 1, 0, 0, 0, 0) end
	end
	return obj
end
doortiles = {}
doortile = {}
doorquad1 = love.graphics.newQuad(0, 0, 64, 64, 256, 64)
doorquad2 = love.graphics.newQuad(64, 0, 64, 64, 256, 64)
doorquad3 = love.graphics.newQuad(128, 0, 64, 64, 256, 64)
doorquad4 = love.graphics.newQuad(192, 0, 64, 64, 256, 64)
function doortile:New(x, y)
	obj = {}
	obj.x = x or 0
	obj.y = y or 0
	obj.w = 64
	obj.h = 64
	obj.unlocked = false
	obj.frame = 1
	obj.frametime = 0
	obj.dying = false
	function obj:update(dt)
		if self.dying and self.frame < 5 then
			self.frametime = self.frametime + 100*dt
			if self.frametime > 1 then
				self.frame = self.frame + 1
				self.frametime = 0
			end
		end
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			if KEYS > 0 and not self.unlocked then
				self.unlocked = true
				self.dying = true
				KEYS = KEYS - 1
				doorsnd:stop()
				doorsnd:play()
				self.dying = true
			elseif not self.unlocked then
				doGameOver()
			end
		end
	end
	function obj:draw()
		if self.frame < 5 then 
			if self.frame == 1 then love.graphics.drawq(doorimg, doorquad1, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
			elseif self.frame == 2 then love.graphics.drawq(doorimg, doorquad2, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
			elseif self.frame == 3 then love.graphics.drawq(doorimg, doorquad3, self.x, self.y, 0, 1, 1, 0, 0, 0, 0)
			else love.graphics.drawq(doorimg, doorquad4, self.x, self.y, 0, 1, 1, 0, 0, 0, 0) end
		end
	end
	return obj
end