buttonz = {}
menuButtons = {}
function buttonz:New(label, x, y, w, h, func)
	obj = {}
	obj.label = label or "undefined"
	obj.x = x or 0
	obj.y = y or 0
	obj.w = w or 64
	obj.h = h or 64
	obj.func = func
	function obj:draw()
		if mouseTouch(love.mouse.getX(), love.mouse.getY(), self) then
			love.graphics.setColor(60, 60, 60, 255)
			love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.setFont(buttonFont)
			love.graphics.printf(self.label, self.x, self.y + self.h/2 - 8, self.w, "center")
		else
			love.graphics.setColor(20, 20, 20, 255)
			love.graphics.rectangle("fill", self.x, self.y, self.w, self.h)
			love.graphics.setColor(155, 155, 155, 255)
			love.graphics.rectangle("line", self.x, self.y, self.w, self.h)
			love.graphics.setColor(255, 255, 255, 255)
			love.graphics.setFont(buttonFont)
			love.graphics.printf(self.label, self.x, self.y + self.h/2 - 8, self.w, "center")
		end
	end
	function obj:exe(mousex, mousey)
		if func and mouseTouch(mousex, mousey, self) then
			self:func()
		end
	end
	return obj
end
